import { contextFactory } from '../../../__tests__/factories';
import { ElementEventStrategy } from './ElementEventStrategy';
import { EventStrategyResolver } from './EventStrategyResolver';
import { PageEventStrategy } from './PageEventStrategy';
describe('EventStrategyResolver', function () {
    var resolver = new EventStrategyResolver();
    var context = contextFactory.build();
    var strategy;
    describe('when event type is "element click"', function () {
        var props = {
            event: 'ElementClick',
            cssSelector: '.test'
        };
        beforeEach(function () {
            strategy = resolver.resolveStrategyByEventType(context, props);
        });
        it('should return ElementEventStrategy', function () {
            expect(strategy).toBeInstanceOf(ElementEventStrategy);
        });
    });
    describe('when event type is "element mouse over"', function () {
        var props = {
            event: 'ElementMouseOver',
            cssSelector: '.test'
        };
        beforeEach(function () {
            strategy = resolver.resolveStrategyByEventType(context, props);
        });
        it('should return ElementEventStrategy', function () {
            expect(strategy).toBeInstanceOf(ElementEventStrategy);
        });
    });
    describe('when event type is "page view"', function () {
        var props = {
            event: 'PageView',
            urlPattern: ''
        };
        beforeEach(function () {
            strategy = resolver.resolveStrategyByEventType(context, props);
        });
        it('should return PageEventStrategy', function () {
            expect(strategy).toBeInstanceOf(PageEventStrategy);
        });
    });
});
//# sourceMappingURL=EventStrategyResolver.test.js.map