jest.mock('../Triggers');
jest.mock('../Steps');
import { WorkflowManager } from './WorkflowManager';
import { TriggerManager } from '../Triggers';
import { StepContainerManager } from '../Steps';
import { mock } from 'jest-mock-extended';
import { contextFactory, workflowFactory } from '../__tests__/factories';
var mockedTriggerManager = TriggerManager;
var mockedStepContainerManager = StepContainerManager;
beforeEach(function () {
    mockedStepContainerManager.mockClear();
    mockedTriggerManager.mockClear();
});
describe('WorkflowManager', function () {
    var workflowManager;
    var workflowConfig;
    var workflowContext;
    var packageMemoryCacheMock;
    var loggerMock;
    var eventLoggerMock;
    beforeEach(function () {
        workflowConfig = workflowFactory.build();
        workflowContext = contextFactory.build();
        packageMemoryCacheMock = mock();
        loggerMock = mock();
        eventLoggerMock = mock();
        workflowManager = new WorkflowManager(workflowContext, workflowConfig, packageMemoryCacheMock, loggerMock, eventLoggerMock);
    });
    describe('start()', function () {
        var mockTriggerManagerInstance;
        var mockStepContainerManagerInstance;
        beforeEach(function () {
            mockTriggerManagerInstance = mockedTriggerManager.mock.instances[0];
            mockStepContainerManagerInstance = mockedStepContainerManager.mock.instances[0];
            workflowManager.start();
        });
        it('should start the TriggerManager', function () {
            expect(mockTriggerManagerInstance.start).toBeCalled();
        });
        describe('when trigger is fired', function () {
            beforeEach(function () {
                var _a;
                (_a = mockTriggerManagerInstance.onTriggered) === null || _a === void 0 ? void 0 : _a.call(mockTriggerManagerInstance);
            });
            it('should start the StepContainerManager', function () {
                // TODO: test that start is called with context.trigger event.
                expect(mockStepContainerManagerInstance.start).toBeCalled();
            });
        });
    });
});
//# sourceMappingURL=WorkflowManager.test.js.map