import * as Factory from 'factory.ts';
import { SessionManager } from '../../tracking';
import { Context } from '../Context';
export var triggerFactory = Factory.Sync.makeFactory({
    event: 'ElementClick',
    cssSelector: '.some-css-selector'
});
export var stepFactory = Factory.Sync.makeFactory({
    uses: 'https://some-url',
    name: 'some-step-name',
    needs: {
        name: 'some-other-step',
        event: 'OnSubmit'
    }
});
export var identityFactory = Factory.Sync.makeFactory({
    identity: 'someData.someUser.email',
    properties: [
        {
            name: 'someProp',
            variable: 'someData.someUser.age'
        }
    ]
});
export var workflowFactory = Factory.Sync.makeFactory({
    name: 'some-trigger',
    triggers: triggerFactory.buildList(1),
    steps: stepFactory.buildList(2),
    identitySource: identityFactory.build()
});
export var contextMetadataFactory = Factory.Sync.makeFactory({
    name: 'some-workflow'
});
export var sessionIdentityFactory = Factory.Sync.makeFactory({
    userId: 'test-user-id',
    sessionId: 'test-session-id'
});
export var workflowContextEventsFactory = Factory.Sync.makeFactory({
    'test-step': {
        'test-event': {
            data: {
                someData: 'test-data'
            }
        }
    }
});
export var contextFactory = Factory.Sync.makeFactory({
    identity: sessionIdentityFactory.build(),
    metadata: contextMetadataFactory.build(),
    events: workflowContextEventsFactory.build(),
    clone: function () {
        return new Context(new SessionManager('envId'), contextMetadataFactory.build(), workflowContextEventsFactory.build());
    }
});
//# sourceMappingURL=factories.js.map