"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var IdentitySourceManager_1 = require("./IdentitySourceManager");
describe('IdentitySourceManager', function () {
    var sourceMan;
    var validDataSource = {
        userData: {
            email: 'testuser@gmail.com',
            firstName: 'John',
            lastName: 'Doe',
            contacts: [
                { type: 'home', number: '+1-876-1234-567' },
                { type: 'work', number: '+1-876-4321-765' }
            ]
        }
    };
    var emptyDataSource = {};
    it('should return the correct properties', function () {
        var _a, _b;
        sourceMan = new IdentitySourceManager_1.IdentitySourceManager({
            identity: 'userData.email',
            properties: [
                { name: 'name', variable: 'userData.firstName' },
                { name: 'number', variable: 'userData.contacts.1.number' }
            ]
        });
        var identity = sourceMan.fetchIdentityData(validDataSource);
        expect(identity.identity).toBe('testuser@gmail.com');
        expect(identity.properties).not.toBe(undefined);
        expect((_a = identity.properties) === null || _a === void 0 ? void 0 : _a.name).toBe('John');
        expect((_b = identity.properties) === null || _b === void 0 ? void 0 : _b.number).toBe('+1-876-4321-765');
    });
    it('should return empty values', function () {
        sourceMan = new IdentitySourceManager_1.IdentitySourceManager({
            identity: 'userData.email',
            properties: [
                { name: 'name', variable: 'userData.firstName' },
                { name: 'number', variable: 'userData.contacts.1.number' }
            ]
        });
        var identity = sourceMan.fetchIdentityData(emptyDataSource);
        expect(identity.identity).toBe(undefined);
        expect(identity.properties).not.toBe(undefined);
    });
});
//# sourceMappingURL=IdentitySourceManager.test.js.map