import { IEvent } from 'ste-events';
import { SessionProperties } from '../models';
import { SessionIdentity } from '@samelogic/steps';
import { SLUser } from '../../models';
export interface OnPropertiesChangedEvent {
    property: 'properties';
    value: SessionProperties;
}
export interface OnIdentityChangedEvent {
    property: 'identity';
    value: SessionIdentity;
}
declare type OnChangedEvent = OnPropertiesChangedEvent | OnIdentityChangedEvent;
export declare class SessionManager {
    private readonly envId;
    private readonly cookieApi;
    private _onChanged;
    constructor(envId: string, user?: SLUser);
    setSessionProperties(sessionProperties: SessionProperties): void;
    setSessionIdentity(sessionIdentity: SessionIdentity): void;
    setUser(user?: SLUser): void;
    getUser(): SLUser | null;
    getBase64User(): string;
    /**
     * Get the session identity from the cookie. If it does not exist, one will be created.
     */
    getSessionIdentity(): SessionIdentity;
    private getIdentity;
    resetSessionIdentity(): void;
    get onChanged(): IEvent<SessionManager, OnChangedEvent>;
}
export {};
//# sourceMappingURL=SessionManager.d.ts.map