import { WorkflowContext, Metadata, EventsRecords, SessionIdentity } from '@samelogic/steps';
import { SessionManager } from '../../tracking/sessions';
/**
 * Context is a container for the current state of the workflow.
 * It is passed to each step in the workflow.
 * It is used to store state and manage `onComplete` events.
 */
export declare class Context implements WorkflowContext {
    private readonly sessionManager;
    readonly metadata: Metadata;
    readonly events: EventsRecords;
    constructor(sessionManager: SessionManager, metadata: Metadata, events: EventsRecords);
    identity: SessionIdentity;
    clone(events?: EventsRecords): Context;
}
//# sourceMappingURL=Context.d.ts.map