import { StepPackage } from '@samelogic/steps';
import { RemotePackageRepository } from './RemotePackageRepository';
/**
 * PackageMemoryCache is used for setting up a cache of StepPackages
 * that will be used throughout the whole lifetime of the engine.
 *
 * The goal is to initialize the cache and pass this cache into anything that
 * requires the retrieval of the package.
 */
export declare class PackageMemoryCache {
    private readonly packageRepository;
    private cacheMap;
    constructor(packageRepository: RemotePackageRepository);
    initialize(urls: string[]): Promise<void>;
    get(url: string): Promise<StepPackage>;
}
//# sourceMappingURL=PackageMemoryCache.d.ts.map