"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mergeStepEventIntoEventRecords_1 = require("./mergeStepEventIntoEventRecords");
describe('mergeStepEventIntoEventRecords()', function () {
    describe.each([
        {
            name: 'when event is empty',
            events: {},
            stepEvent: {
                stepName: 'test-step',
                event: 'test-event',
                data: {
                    someData: 'test-data'
                }
            },
            expected: {
                'test-step': {
                    'test-event': {
                        data: {
                            someData: 'test-data'
                        }
                    }
                }
            }
        },
        {
            name: 'when events is not empty',
            events: {
                'root-step': {
                    'root-test-event': {
                        data: {
                            test: 'test'
                        }
                    }
                }
            },
            stepEvent: {
                stepName: 'test-step',
                event: 'test-event',
                data: {
                    someData: 'test-data'
                }
            },
            expected: {
                'root-step': {
                    'root-test-event': {
                        data: {
                            test: 'test'
                        }
                    }
                },
                'test-step': {
                    'test-event': {
                        data: {
                            someData: 'test-data'
                        }
                    }
                }
            }
        }
    ])('$name', function (_a) {
        var events = _a.events, stepEvent = _a.stepEvent, expected = _a.expected;
        it('should merge the step event data with existing data', function () {
            var got = (0, mergeStepEventIntoEventRecords_1.mergeStepEventIntoEventRecords)(events, stepEvent);
            expect(got).toEqual(expected);
        });
    });
});
//# sourceMappingURL=mergeStepEventIntoEventRecords.test.js.map