"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventStrategyResolver = void 0;
var ElementEventStrategy_1 = require("./ElementEventStrategy");
var PageEventStrategy_1 = require("./PageEventStrategy");
var EventStrategyResolver = /** @class */ (function () {
    function EventStrategyResolver() {
    }
    EventStrategyResolver.prototype.resolveStrategyByEventType = function (context, props) {
        switch (props.event) {
            case 'ElementClick':
            case 'ElementMouseOver':
                return new ElementEventStrategy_1.ElementEventStrategy(context, props);
            case 'PageView':
                return new PageEventStrategy_1.PageEventStrategy(context, props);
            default:
                throw Error("Unknown eventType");
        }
    };
    return EventStrategyResolver;
}());
exports.EventStrategyResolver = EventStrategyResolver;
//# sourceMappingURL=EventStrategyResolver.js.map