"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var factories_1 = require("../../../__tests__/factories");
var ElementEventStrategy_1 = require("./ElementEventStrategy");
var EventStrategyResolver_1 = require("./EventStrategyResolver");
var PageEventStrategy_1 = require("./PageEventStrategy");
describe('EventStrategyResolver', function () {
    var resolver = new EventStrategyResolver_1.EventStrategyResolver();
    var context = factories_1.contextFactory.build();
    var strategy;
    describe('when event type is "element click"', function () {
        var props = {
            event: 'ElementClick',
            cssSelector: '.test'
        };
        beforeEach(function () {
            strategy = resolver.resolveStrategyByEventType(context, props);
        });
        it('should return ElementEventStrategy', function () {
            expect(strategy).toBeInstanceOf(ElementEventStrategy_1.ElementEventStrategy);
        });
    });
    describe('when event type is "element mouse over"', function () {
        var props = {
            event: 'ElementMouseOver',
            cssSelector: '.test'
        };
        beforeEach(function () {
            strategy = resolver.resolveStrategyByEventType(context, props);
        });
        it('should return ElementEventStrategy', function () {
            expect(strategy).toBeInstanceOf(ElementEventStrategy_1.ElementEventStrategy);
        });
    });
    describe('when event type is "page view"', function () {
        var props = {
            event: 'PageView',
            urlPattern: ''
        };
        beforeEach(function () {
            strategy = resolver.resolveStrategyByEventType(context, props);
        });
        it('should return PageEventStrategy', function () {
            expect(strategy).toBeInstanceOf(PageEventStrategy_1.PageEventStrategy);
        });
    });
});
//# sourceMappingURL=EventStrategyResolver.test.js.map