import { TriggerEventProps } from '../../../../models';
import { EventStrategy } from './EventStrategy';
export declare type PageEvent = {
    href: string;
};
/**
 * The shape of the payload for the PageView event.
 * @public
 */
export interface PageEventProps extends TriggerEventProps {
    event: 'PageView';
    /**
     * A URL that can contain wildcards.
     * @remarks
     * For example, `https://samelogic.com/*\/docs` matches all URLs that contain `samelogic.com` and end with `/docs`.
     */
    urlPattern: string;
}
export declare class PageEventStrategy extends EventStrategy<PageEventProps, PageEvent> {
    private previousUrl;
    start(): void;
    private handlePageView;
    private isConditionMet;
    private isUrlMatch;
}
//# sourceMappingURL=PageEventStrategy.d.ts.map