"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TriggerEvent = void 0;
var EventStrategies_1 = require("./EventStrategies");
/**
 * TriggerEvent acts as a wrapper context for the event strategies
 */
var TriggerEvent = /** @class */ (function () {
    function TriggerEvent(context, props) {
        var _this = this;
        this.context = context;
        this.props = props;
        this.handleTriggerEvent = function (event) {
            var _a;
            (_a = _this.onChanged) === null || _a === void 0 ? void 0 : _a.call(_this, event);
        };
        var strategy = this.resolveStrategy();
        strategy.onEventTriggered = this.handleTriggerEvent;
        this.strategy = strategy;
    }
    TriggerEvent.prototype.start = function () {
        this.strategy.start();
    };
    TriggerEvent.prototype.resolveStrategy = function () {
        var resolver = new EventStrategies_1.EventStrategyResolver();
        return resolver.resolveStrategyByEventType(this.context, this.props);
    };
    return TriggerEvent;
}());
exports.TriggerEvent = TriggerEvent;
//# sourceMappingURL=TriggerEvent.js.map