import { Logger, StepPackage, Step, WorkflowContext, EventCallbackFunction } from '@samelogic/steps';
export declare class MockStep extends Step<Record<string, string>> {
    onEventTriggered: EventCallbackFunction | undefined;
    name: string;
    run(_context: WorkflowContext, _props: Record<string, string>): Promise<void>;
    constructor(logger: Logger);
}
export declare const schema: {
    events: {
        OnRun: {
            title: string;
            type: string;
            properties: {
                key: {
                    type: string;
                };
                value: {
                    type: string;
                };
            };
            additionalProperties: boolean;
            required: string[];
        };
    };
    props: {
        title: string;
        type: string;
        properties: {
            prop1: {
                type: string;
            };
            prop2: {
                type: string;
            };
            intProp: {
                type: string;
            };
        };
        additionalProperties: boolean;
        required: string[];
    };
};
export declare const stepPackage: StepPackage;
//# sourceMappingURL=MockPackage.d.ts.map