"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.contextFactory = exports.workflowContextEventsFactory = exports.sessionIdentityFactory = exports.contextMetadataFactory = exports.workflowFactory = exports.identityFactory = exports.stepFactory = exports.triggerFactory = void 0;
var Factory = __importStar(require("factory.ts"));
var tracking_1 = require("../../tracking");
var Context_1 = require("../Context");
exports.triggerFactory = Factory.Sync.makeFactory({
    event: 'ElementClick',
    cssSelector: '.some-css-selector'
});
exports.stepFactory = Factory.Sync.makeFactory({
    uses: 'https://some-url',
    name: 'some-step-name',
    needs: {
        name: 'some-other-step',
        event: 'OnSubmit'
    }
});
exports.identityFactory = Factory.Sync.makeFactory({
    identity: 'someData.someUser.email',
    properties: [
        {
            name: 'someProp',
            variable: 'someData.someUser.age'
        }
    ]
});
exports.workflowFactory = Factory.Sync.makeFactory({
    name: 'some-trigger',
    triggers: exports.triggerFactory.buildList(1),
    steps: exports.stepFactory.buildList(2),
    identitySource: exports.identityFactory.build()
});
exports.contextMetadataFactory = Factory.Sync.makeFactory({
    name: 'some-workflow'
});
exports.sessionIdentityFactory = Factory.Sync.makeFactory({
    userId: 'test-user-id',
    sessionId: 'test-session-id'
});
exports.workflowContextEventsFactory = Factory.Sync.makeFactory({
    'test-step': {
        'test-event': {
            data: {
                someData: 'test-data'
            }
        }
    }
});
exports.contextFactory = Factory.Sync.makeFactory({
    identity: exports.sessionIdentityFactory.build(),
    metadata: exports.contextMetadataFactory.build(),
    events: exports.workflowContextEventsFactory.build(),
    clone: function () {
        return new Context_1.Context(new tracking_1.SessionManager('envId'), exports.contextMetadataFactory.build(), exports.workflowContextEventsFactory.build());
    }
});
//# sourceMappingURL=factories.js.map